unit textunit;
interface
uses dos,crt,graph;
const year0: word= 1901;
      julinitflg: boolean = false;
      left = 203; right = 205; up = 200; down = 208; PgUp = 201; PgDn = 209;
      Ins = 210; Del = 211; EndKey = 207; Home = 199;
      CLeft =  243; Cright = 244; CEnd = 245;
      f1 = 187; f2 = 188; f3 = 189; f4 = 190; f5 = 191;
      f6 = 192; f7 = 193; f8 = 194; f9 = 195; f10 = 196;
      Altf1 = 232;Altf2 = 233;Altf3 = 234;Altf4 = 235;Altf5 = 236;
      Altf6 = 237;Altf7 = 238;Altf8 = 239;Altf9 = 240;Altf10 = 241;
      f11 = 261; F12 = 262;
      EscKey = $1b;
      vert = 179; horz = 196; ulc = 218; urc = 191; llc = 192; lrc = 217;
      topt = 194; bott = 193; leftt = 195; rightt = 180; cross = 197;


type  str79 = string[79];
      dualchartype = record t,a: str79; end;
      textbuffertype = array[0..24] of dualchartype;
      termsettype = set of byte;

const termset:termsettype =
                 [Up,Down,Left,Right,Ins,Del,Home,PgUp,PgDn,EscKey,EndKey,$0d];
      getreal: boolean = true;

procedure   curson;
procedure   cursoff;
procedure   textbox(x1,y1,x2,y2: integer);
function    getcod: byte;
procedure   dots(n: integer);
procedure   blanks(n: integer);
function    getnumstr(var n: integer; w: integer): byte;
function    getcharstr(var s: string; l: integer): byte;
function    getrealstr(var n: real; w: integer): byte;
procedure   graphwritestr(var s: string; x,y,n,Fcol,Bcol: word);
procedure   graphwritereal(var n: real;x,y,w,d,Fcol,Bcol: word);
procedure   graphwriteint(var n: integer;x,y,w,Fcol,Bcol: word);
function    graphgetstr(rstr: boolean; var s: string; xx,yy,ww,Fcol,Bcol: word): byte;
function    graphgetreal(var n: real; xx,yy,ww,dd,Fcol,Bcol: word): byte;
function    graphgetint(var n: integer; xx,yy,ww,Fcol,Bcol: word): byte;
procedure   WriteStr(s: dualchartype);
function    GetFormFile(var formatbuf:textbuffertype): boolean;
procedure   SaveForm(var formatbuf: textbuffertype);
function    EditLine(var s:dualchartype): byte;
procedure   EditText(var buffer: textbuffertype; nlines,startline: byte);

implementation

var bufptr: integer;
    attr: char;
    filename: dualchartype;
    formfile: file of textbuffertype;
    regs: Registers;

procedure curson;
begin
 with regs do
 begin
  ah := 1;
  ch := 0;
  cl := 3;
  intr($10,regs);
 end;
end;

procedure cursoff;
begin
 with regs do
 begin
  ah := 1;
  ch := 14;
  cl := 0;
  intr($10,regs);
 end;
end;


procedure textbox(x1,y1,x2,y2: integer);
var i,j: integer;
begin
 gotoxy(x1,y1); write(chr(ulc));
 for i := x1 + 1 to x2 - 1 do write(chr(horz)); write(chr(urc));
 for i :=  y1 + 1 to y2 - 1 do
  begin gotoxy(x1,i); write(chr(vert)); end;
 for i :=  y1 + 1 to y2 - 1 do
  begin gotoxy(x2,i); write(chr(vert)); end;
 gotoxy(x1,y2); write(chr(llc));
 for i := x1 + 1 to x2 - 1 do write(chr(horz)); write(chr(lrc));
end;

function getcod: byte;
var ch: byte;
begin
 ch := ord(readkey);
 if (ch = 0) and keypressed then
  ch := ord(readkey) or $80;
 getcod := ch;
end;

procedure dots(n: integer);
var i,x,y: integer;
begin
 if n = 0 then exit;
 x := wherex; y := wherey;
 for i := 1 to n do write('.');
 gotoxy(x,y);
end;

procedure blanks(n: integer);
var i,x,y: integer;
begin
 if n = 0 then exit;
 x := wherex; y := wherey;
 for i := 1 to n do write(' ');
 gotoxy(x,y);
end;

procedure graphwritestr(var s: string; x,y,n,Fcol,Bcol: word);
var w,h: word;
begin
 SetFillStyle(1,Bcol);
 SetColor(Fcol);
 w := n * textwidth('T'); h := textheight('T');
 bar(x,y,x+w,y+h);
 outtextxy(x + w - textwidth(s) + 1,y,s);
end;

procedure graphwritereal(var n: real;x,y,w,d,Fcol,Bcol: word);
var realstr: string;
    realval: real;
    error: integer;
    cmd: byte;
begin
 str(n:w:d,realstr);
 graphwritestr(realstr,x,y,w,Fcol,Bcol);
end;

procedure graphwriteint(var n: integer;x,y,w,Fcol,Bcol: word);
var intstr: string;
    intval: real;
    error: integer;
    cmd: byte;
begin
 str(n:w,intstr);
 graphwritestr(intstr,x,y,w,Fcol,Bcol);
end;

function  graphgetstr(rstr: boolean; var s: string; xx,yy,ww,Fcol,Bcol: word): byte;
var stemp: string;
    cmd: byte;
    changed: boolean;
    ok: boolean;
begin
 stemp := s;  cmd := 0; changed := false;
 repeat
  graphwritestr(stemp,xx,yy,ww,Fcol,Bcol);
  cmd := getcod;
  if rstr then ok := chr(cmd) in ['0'..'9','.','+','-']
  else ok := not (cmd in termset);
  if ok then
  begin
   if not changed then
    begin stemp := ''; changed := true; end;
   if cmd = 8 then delete(stemp,length(stemp),1)
   else if length(stemp) < ww then
     stemp := stemp + chr(cmd and $7f);
  end;
 until not ok;
 if changed then s := stemp;
 graphgetstr := cmd;
end;

function  graphgetreal(var n: real; xx,yy,ww,dd,Fcol,Bcol: word): byte;
var realstr: string;
    realval: real;
    error: integer;
    cmd: byte;
begin
 repeat
  str(n:ww:dd,realstr);
  cmd := graphgetstr(getreal,realstr,xx,yy,ww,Fcol,Bcol);
  val(realstr,realval,error);
 until error = 0;
 n := realval;
 graphgetreal := cmd;
end;

function  graphgetint(var n: integer; xx,yy,ww,Fcol,Bcol: word): byte;
var intstr: string;
    intval: integer;
    error: integer;
    cmd: byte;
begin
 repeat
  str(n:ww,intstr);
  cmd := graphgetstr(not getreal,intstr,xx,yy,ww,Fcol,Bcol);
  val(intstr,intval,error);
 until error = 0;
 n := intval;
 graphgetint := cmd;
end;

function getnumstr(var n: integer; w: integer): byte;
var nn,x,y,i: integer;
    c: byte;
    sign: string[1];
    numstr: string[20];
begin
 nn := 0; sign := ' ';
 x := wherex; y := wherey;
 numstr := '';
 repeat
  gotoxy(x,y);
  c := getcod;
  if (chr(c) in ['-','+']) and (w > 1) then
   begin
    if chr(c) = '-' then sign := '-'
    else
    if chr(c) = '+' then sign := ' ';
    if sign = '-' then numstr := chr(c) + numstr;
    gotoxy(x - w,y); blanks(w);
    if w = 1 then write(numstr:1) else write(numstr:w);
   end
  else
  if c in [$30..$39] then
   begin
    nn := 10 * nn + (c - $30);
    numstr := numstr + chr(c);
    if w > 1 then if(length(numstr) > w) then delete(numstr,length(numstr),1);
    gotoxy(x - w,y); blanks(w);
    if w = 1 then write(numstr:1) else write(numstr:w);
   end
  else if c = del then begin nn := maxint; sign := ' '; end
  else if c = 8 then
   begin
    gotoxy(x - w,y); blanks(w);
    numstr := ''; nn := 0; sign := ' ';
   end;
 until (c in termset) or (w = 1);
 getnumstr := c;
 if nn = maxint then n := maxint
 else
 if length(numstr) > 0 then
  if (sign = ' ') or (w = 1) then n := nn else n := -nn;
end;

function getrealstr(var n: real; w: integer): byte;
var x,y,i,code: integer;
    c: byte;
    nn: real;
    sign: string[1];
    numstr: string[20];
begin
 x := wherex - w; y := wherey; numstr := '';
 repeat
  sign := ' ';
  repeat
   c := getcod;
    if chr(c) in ['-','+'] then
     begin
      if chr(c) = '-' then sign := '-'
     else
     if chr(c) = '+' then sign := ' ';
    end
   else
   if c in [$30..$39,ord('.')] then
    begin
     numstr := numstr + chr(c);
     if w > 1 then if(length(numstr) > w) then delete(numstr,length(numstr),1);
     gotoxy(x,y);
     if w = 1 then write(numstr:1) else write(sign + numstr:w);
    end
   else if c = 8 then
    begin
     gotoxy(x,y);
     blanks(w);
     numstr := ''; sign := ' ';
     gotoxy(x + w,y);
    end;
  until (c in termset) or (w = 1);
  getrealstr := c;
  code := 0;
  if length(numstr) > 0 then
   begin
    numstr := sign + numstr;
    val(numstr,nn,code);
   end;
  if code <> 0 then
   begin
    gotoxy(x,y); blanks(w);
   end;
  until (length(numstr) = 0) or (code = 0);
  if length(numstr) > 0 then n := nn;
end;

function getcharstr(var s: string; l: integer): byte;
var chstr: string[80];
    cmd: byte;
    ch: char;
    done,first: boolean;
    x,y,ln: integer;
begin
 x := wherex; y := wherey;
 chstr := s;
 first := true;
 gotoxy(x,y);
 done := false;
 repeat
  cmd := getcod;
  ch := chr(cmd);
  ln := length(chstr);
  if (cmd in [$20..$7f]) and (ln <= l) then
   begin
    if first then
     begin
      chstr := '';
      gotoxy(x,y);
      dots(l);
      ln := 0;
     end;
    if ln >= l then write(chr(8)); write(ch);
    if ln < l then chstr := chstr + ch
    else chstr[ln] := ch;
   end
  else
  if cmd = 8 then
   if length(chstr) > 0 then
    begin
     delete(chstr,length(chstr),1);
     write(^h,' ',^h);
    end
   else
    if cmd = Del then chstr := '';
  first := false;
 until cmd in termset;
 gotoxy(x,y);
 if (length(chstr) > 0) then
  if (cmd = Del) then s := '' else s := chstr;
 getcharstr := cmd;
end;

procedure writestr(s: dualchartype);
var i: integer;
begin
 for i := 1 to length(s.t) do
 begin
  case s.a[i] of
   ^b: textattr := $0f;
   ^n: textattr := $07;
   ^r: textattr := $70;
   ^u: textattr := 1;
  end;
  write(s.t[i]);
 end;
 textattr := $0f;
end;

function EditLine(var s:dualchartype): byte;
var linebuf: dualchartype;
    cmd: byte;
    s1: string[1];
    x,y: integer;
begin
 if bufptr > length(s.t) then bufptr := length(s.t);
 if bufptr < 1 then bufptr := 1;
 linebuf := s; x := wherex; y := wherey;
 repeat
  gotoxy(1,y); clreol;
  writestr(linebuf);
  gotoxy(bufptr,y);
  cmd := getcod;
  case cmd of
   Del: begin
         delete(linebuf.t,bufptr,1);
         delete(linebuf.a,bufptr,1);
         if length(linebuf.t) = 0 then
          begin editline := cmd; exit; end;
        end;
   $08: begin
         if bufptr > 1 then dec(bufptr);
         delete(linebuf.t,bufptr,1);
         delete(linebuf.a,bufptr,1);
         if length(linebuf.t) = 0 then
          begin editline := cmd; exit; end;
        end;
  Left: if (bufptr > 1) then dec(bufptr);
 Right: if (bufptr <= length(linebuf.t)) and (bufptr < 79) then
         begin
          inc(bufptr);
          if(bufptr > length(linebuf.t)) then
           begin
            linebuf.t := linebuf.t + ' ';
            linebuf.a := linebuf.a + attr;
           end;
         end;
  Cleft: bufptr := 1;
  Cright: bufptr := length(linebuf.t);
    ord(^b),
    ord(^n),
    ord(^r),
    ord(^u):   attr := chr(cmd);
    else if not (cmd in [EndKey,Up,Down,$0d,Home,Ins]) and
          (cmd and $80 = 0) then
      begin
       s1 := chr(cmd);
       insert(s1,linebuf.t,bufptr);
       s1 := attr;
       insert(s1,linebuf.a,bufptr);
       if bufptr < 79 then inc(bufptr);
      end;
 end;
until (cmd in termset);
EditLine := cmd;
if linebuf.t[0] > chr(79) then linebuf.t[0] := chr(79);
s := linebuf;
end;

function getformfile(var formatbuf:textbuffertype): boolean;
var i,j,result: integer;
    cmd: byte;
    ch: char;
begin
 repeat
   clrscr;
   gotoxy(1,12);
   filename.t := '';
   filename.a := '';
   write('FORMAT FILE SPEC (enter for new, End Key to quit): ');
   gotoxy(1,14);
   dots(60);
   cmd := editline(filename);
   textattr := $0f;
   if cmd = EndKey then begin clrscr; halt; end;
   if length(filename.t) > 0 then
    begin
     assign(formfile,filename.t);
     {$i-}
     reset(formfile);
     {$i+}
     result := IOResult;
     if result <> 0 then
      begin
       gotoxy(1,16); write('FILE NOT FOUND: TRY AGAIN? Y/N: ');
       ch := readkey;
       if ch in ['n','N'] then
       begin clrscr; getformfile := false; exit; end;
      end
     else
      begin
       read(formfile,formatbuf);
       close(formfile);
      end;
    end
   else
    begin
     for i := 0 to 24 do
      begin
       for j := 1 to 79 do
        begin
         formatbuf[i].t[j] := ' ';
         formatbuf[i].a[j] := ^u;
        end;
        formatbuf[i].t[0] := chr(79);
        formatbuf[i].a[0] := chr(79);
        if i = 0 then formatbuf[i].a[1] := ^r;
      end;
    end;
  until (result = 0) or (length(filename.t) = 0);
  GetFormFile := true;
end;

procedure saveform(var formatbuf: textbuffertype);
var cmd: byte;
    savedscreen: array[0..3999] of byte;
    scrptr: pointer;

begin
 scrptr := ptr($b000,0000);
 move(scrptr^,savedscreen,4000);
 textattr := $0f; clrscr;
 gotoxy(1,12);
 textattr := $0f;
 write('SAVE AS (End Key to abandon) :');
 gotoxy(1,14);
 textattr := $70;
 writestr(filename);
 gotoxy(1,14);
 cmd := editline(filename);
 textattr := $0f;
 if cmd <> EndKey then
  begin
   assign(formfile,filename.t);
   rewrite(formfile);
   write(formfile,formatbuf);
   close(formfile);
  end;
 move(savedscreen,scrptr^,4000);
end;


procedure EditText(var buffer: textbuffertype; nlines,startline: byte);
const lineptr: integer = 0;
var   i,j: integer;
      cmd: byte;

procedure showscreen;
var i: integer;
begin
 clrscr;
 for i := 0 to nlines - 1 do
  begin
   gotoxy(1,i + 1); clreol;
   writestr(buffer[i]);
  end;
end;

begin
 for i := 0 to nlines - 1 do
  begin
   gotoxy(1,i + 1); clreol;
   writestr(buffer[i]);
  end;
 bufptr := 1; attr := ^r;
 repeat
  gotoxy(1,startline + lineptr);
  cmd := EditLine(buffer[lineptr]);
  case cmd of
   Up: if lineptr > 0 then dec(lineptr) else lineptr := nlines - 1;
   Down,$0d:
       if lineptr >= nlines - 1 then lineptr := 0 else inc(lineptr);
   Ins: begin
         for j := 24 downto lineptr + 1 do buffer[j] := buffer[j-1];
         buffer[lineptr].t := '';
         buffer[lineptr].a := '';
         showscreen;
        end;
   Del: begin
         for j := lineptr to nlines - 2 do buffer[j] := buffer[j+1];
         for j := 1 to 79 do
          begin
           buffer[nlines - 1].t[j] := ' ';
           buffer[nlines - 1].a[j] := ^u;
          end;
         showscreen;
        end;
  end;
  if cmd = $0d then bufptr := 1;
 until cmd = EndKey;
end;

end.
